#!c:/local/python2.3/pythonw.exe
import YMLD
import cgi
import cgitb; cgitb.enable()
import re

def index_page():
  print header('YourMamaLovesDrama:: Home')
  conn = YMLD.database_connect()
  productions = YMLD.select_all_shows(conn)
  print display_productions(productions)
  print footer()

def show_page(id):
  print header('YourMamaLovesDrama:: Display Performance')
  conn = YMLD.database_connect()
  num = re.compile('^(\d+)$')
  m = num.search(id)
  if (m):
    performances = YMLD.select_performance_data(conn, int(id))
    seats = YMLD.select_available_seats(conn, performances)
    print display_performances(performances, seats)
  else:
    print "<p>Invalid parameter.</p>"
  print footer()
  
def display_productions(productions):
  form = """<table>
  <tr><th>Title</th><th>Start date</th><th>End date</th></tr>\n"""
  for show in productions:
    form = form + """<tr><td><a href='%s?page=show&id=%s'>%s</a></td>
      <td>%s</td><td>%s</td></tr>\n""" \
      % (url(), str(show[0]), show[1], show[2], show[3])
  return form
  
def display_performances(performances, seats):
  """
  Display performances for a given production with radio buttons
  so a user can display the seats that are available for a given
  performance.
  """
  
  form = """<table>
  <tr><th>Title</th><th>Date</th><th>Time</th><th>Seats</th></tr>\n"""
  for shownum, title, date, time in performances:
    form = form + "<tr>"
    form = form + "<td>" + title + "</td>"
    form = form + "<td>" + date + "</td>"
    form = form + "<td>" + time + "</td>"
    form = form + "<td><form action='" + url() + "?page=view' method='POST'>"
    form = form + "<select name='seat'>"
    for seat, price in seats[str(shownum)]:
      form = form + "<option value='" + str(seat) + "'>"
      form = form + str(price) + "</option>\n"
    form = form + "</select><input type='submit' value='Display' />"
    form = form + "</form></td></tr>\n"
  form = form + "</table>"
  return form

def display_seat_info(id):
  pass
  
def header(title):
  header = "Content-type: text/html\n\n"
  header = header + """<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html
  PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
   "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US"
 xml:lang="en-US">
  <head><title>%s</title></head>
  <body><h1>%s</h1>""" % (title, title)
  return header

def footer():
  return """</body>\n</html>"""
 
def url():
  import os
  
  return os.environ['SCRIPT_NAME']
  
if __name__ == '__main__':
  form = cgi.FieldStorage()
 
  if (not form.has_key('page')):
    index_page()
  elif (form.getvalue('page') == 'show'):
    show_page(form.getvalue('id'))
  elif (form.getvalue('page') == 'view'):
    display_seat_info(form.getvalue('id'))
  else:
    index_page(conn)